#!/bin/bash

# Dieses Skript erlaubt es das Milestone mit einem Debian basierten Betriebssystem zu tethern.
# Das Skript wurde von bigmack83 vom alldroid.org Forum erstellt und basiert auf dem Artikel
# http://www.humans-enabled.com/2009/12/how-to-tether-your-verizon-droid-as.html
# Übersetzt und angepasst für das Motorola Milestone durch nodch.de
#
# current version: 1.0

clear

echo "Wie heisst dein angemeldeter Benutzername?";
echo "";
read uname
home=/home/${uname}

if [ -d ${home} ]; then
  echo "Home-Verzeichnis wurde gefunden. Weiter."
else
  echo "Das Home-Verzeichnis von ${home} wurde nicht gefunden. Stell sicher"
  echo "das es existiert und versuche es erneut";
  exit;
fi

echo "Das Home-Verzeichnis lautet: ${home}";
cd ${home}
echo "";

echo "Ist das Android SDK bereits installiert?";
echo "";
echo "[ j/n ]";
read sdk;
echo "";


if [ $sdk != "j" ]; then
  echo "Bitte das SDK von http://developer.android.com/sdk/index.html";
  echo "herunterladen und in das gewünschte Verzeichnis entpacken";
  echo "Falls es in Home-Verzeichnis entpackt wird, in diesem Fall ${home}";
  echo "benenne es nach dem Entpacken in 'android' um";
  echo "";
  echo "Sobald es entpackt und umbenannt wurde, das Skript erneut starten.";
  echo "";
  echo "Das entpacke Verzeichnis sollte dann in: ${home}/android liegen";
  exit;
  
elif [ $sdk == "j" ]; then
  echo ""
  echo "Sehr gut, wo befindet sich das Verzeichnis? Bitte den vollständigen"
  echo "Systempfad angeben, wie zum Beispiel:"
  echo "${home}/android  <- * ohne / am Ende! *"
  echo ""
  read sdkdir
  tools="${sdkdir}/tools"
  echo ""
  echo "Überprüfung des Verzeichnisses..."

  if [ -d ${sdkdir} ]; then
    echo "Verzeichnis wurde gefunden, weiter...";
  else 
    echo "Das Verzeichnis konnte nicht gefunden werden. Überprüfe den Pfad";
    echo "und versuch es erneut!";
    exit;
  fi

fi


echo ""
echo "Für den nächsten Schritt wird eine funktionierende Internetverbindung"
echo "benötigt, da ein einige Pakete geladen werden müssen. Bitte vor dem"
echo "Ausführen sicherstellen dass eine Verbindung vorhanden ist. Alternativ"
echo "können die Pakete auch über das Milestone geladen, die Links werden"
echo "bereitgestellt."
echo "";
echo "Besteht eine Internetverbindung? Bitte nein eingeben, sollte dies nicht"
echo "der Fall sein, oder die Pakete über einen anderen Weg heruntergeladen"
echo "worden sind und du nun zum Skript zurückkehrst."
echo "[ j/n ]";
read net
echo "";

if [ $net != 'j' ]; then
  echo "Wenn dieser Computer keine Internetverbindung hat können die Pakete"
  echo "am Milestone heruntergeladen und auf die SD-Karte gespeichert"
  echo "werden. Es werden zwei Pakete benötigt, damit es funktioniert:"
  echo "'network-manager-openvpn' and 'openvpn' . Sie können hier"
  echo "heruntergeladen werden:"
  echo "http://packages.ubuntu.com/jaunty/net/network-manager-openvpn"
  echo "http://packages.ubuntu.com/jaunty/net/openvpn"
  echo ""
  echo "// Bitte bedenken, diese Anleitung bezieht sich auf Debian Systeme"
  echo "// falls du kein Debian basiertes System betreibst musst du dir die"
  echo "// Pakete andersweitig beschaffen."
  echo ""
  echo "Überprüfe auch die Abhängigkeiten der Pakete, es kann sein dass"
  echo "noch weitere Pakete heruntergeladen werden müssen, sollten diese"
  echo "noch nicht auf deinem System vorhanden sein. Es ist einfacher"
  echo "wenn dein Computer bei der Benutzung dieses Skriptes über eine"
  echo "Internetverbindung verfügt."
  echo ""
  echo "Welche Pakete benötigt werden zeigt der Aufruf von"
  echo "sudo apt-get install network-manager-openvpn openvpn"
  echo "alle Pakete für Ubuntu findet man hier:"
  echo "http://packages.ubuntu.com/jaunty/net/"
  echo "falls libpkcs11-helper1 benötigt wird:"
  echo "http://packages.ubuntu.com/jaunty/libs/libpkcs11-helper1"
  echo ""
  echo "Sobald diese Pakete geladen wurden, muss man noch zwei weitere"
  echo "Dateien herunterladen und auf die SD-Karte speichern:"
  echo "http://lfx.org/azilink/azilink.apk"
  echo "http://azilink.googlecode.com/files/azilink.ovpn"
  echo ""
  echo "Die APK Datei muss direkt auf dem Milestone installiert werden"
  echo "ASTRO und andere Dateimanager bieten diese Funktion an."
  echo "Sobald die deb Dateien geladen wurden, kopiere sie vom Milestone"
  echo "auf deinen Desktop und installiere sie. Verschieb die apk Datei nach"
  echo "${tools} und die ovpn Datei in dein Home-Verzeichnis nach:"
  echo "${home}"
  echo ""
  echo "Eine beliebige Taste drücken, sobald das alles erledigt ist"
  read ok
else
  echo "";
  echo "Stelle sicher dass das Milestone NICHT mit dem PC verbunden ist!"
  echo "Sollte es über USB am PC angeschlossen sein, dann bitte"
  echo "JETZT ENTFERNEN, sonst kann ADB das Gerät nicht initialisieren."
  echo ""
  echo "Drücke eine beliebige Taste, sobald keine Verbindung mit dem PC besteht"
  read ok
  echo "Alles klar, Download der Dateien beginnt..."
  echo "'network-manager-openvpn' and 'openvpn'"
  echo ""
  sudo apt-get install network-manager-openvpn openvpn
  sudo /etc/init.d/networking restart
  sudo /etc/init.d/NetworkManager restart
  cd ${tools}
  wget http://lfx.org/azilink/azilink.apk
  cd ${home}
  wget http://azilink.googlecode.com/files/azilink.ovpn
fi

echo "Ok, die Dateien sind nun vorhanden, eine kleine Anmerkung, das"
echo "Open VPN Paket muss bereits installiert werden, falls eine Internet-"
echo "Verbindung besteht, dann wurde sie bereits heruntergeladen,"
echo "wenn nicht, dann solltest du sie nun installieren. Den Rest"
echo "übernimmt nun das Skript."
echo ""
echo "Nochmal: Das Milestone sollte NICHT mit dem PC verbunden sein."
echo "Sobald es angeschlossen werden soll, wird die bescheid gegeben!"
read ok
echo ""

echo "erstelle /etc/udev/rules.d/91-android.rules"
sudo touch /etc/udev/rules.d/91-android.rules
sudo chmod 777 /etc/udev/rules.d/91-android.rules
sudo echo 'SUBSYSTEM=="usb", ATTRS{idVendor}=="22b8", SYMLINK+="android_adb", MODE="0666", OWNER="BENUTZERNAME"' > /etc/udev/rules.d/91-android.rules
echo ""
echo "Es wird nun ein Editor geöffnet. Bitte ersetze"
echo "BENUTZERNAME"
echo "mit deinem Benutzernamen. Wenn nach eine Passwort gefragt wird"
echo "gib dein Passwort ein, danach speichern und den Editor schliessen."
echo "Eine beliebige Taste drücken, um die Datei zu ändern."
read ok
sudo gedit /etc/udev/rules.d/91-android.rules
echo "Willkommen zurück, weiter gehts! Bitte eine Taste drücken."
read ok
echo ""
sudo chmod a+r /etc/udev/rules.d/91-android.rules
sudo restart udev

echo "Am Milestone sicherstellen dass USB-Debugging aktiviert ist:"
echo "Einstellungen -> Anwendungen -> Entwicklung -> USB-Debugging [X]"
echo ""
echo "Taste drücken, sobald es aktiviert ist..."
read ok
echo ""
echo "Nun kann das Milestone angeschlossen werden. In der USB Verbindung"
echo "sicherstellen dass die SD-Karte nicht gemountet wird. Verbindungs-"
echo "typ: Keine als Aktion auswählen und am PC die Drahtlose Netzwerk-"
echo "verbindung deaktivieren!"
echo "Ansonsten wird sich die Verbindung zum Milestone regelmässig"
echo "abschalten und wieder aktivieren"
echo "Sobald die WLan PC deaktiviert wurde kann es hier weitergehen:"
echo "Eine beliebige Taste drücken!"
read ok
echo ""
echo "Bitte stelle sicher dass ADB dein Milestone findet und initialisiert:"
echo "Um dies zu überprüfen auf der Konsole folgenden Befehl eingeben:"
echo "adb devices"
echo "Zeigt die Ausgabe etwas Ähnliches wie:"
echo "List of devices attached"
echo "040368270D01####	device"
echo "klappt alles, wenn das hier kommt:"
echo "List of devices attached"
echo "??????????????	unknown device, permission denied"
echo "hat ADB keine Verbindung zum Gerät. Bitte öffne dazu ein neues"
echo "Terminal und setze hier fort sobald du es überprüft hast."
read ok
echo "Hat alles geklappt?"
echo "[ j/n ]"
read result
echo ""

if [ $result != 'j' ]; then
  echo "Das ist nicht gut, bitte lies die Beschreibung zum Android SDK durch"
  echo "und stelle sicher dass es auf deinem System lauffähig ist."
  echo "Du kannst das Skript dann erneut aufrufen und bei der Frage nach den"
  echo "Dateien/der Internetverbindung mit 'n' antworten und es erneut versuchen."
  echo "Viel Erfolg!"
  exit
else
  echo "KLASSE, dann hast du das Tethering nun fast geschafft."
fi

echo "Hast du die azilink.apk bereits auf dem Milestone installiert?"
echo "[ j/n ]"
read install
echo ""

if [ $install == "j" ]; then
  echo "Sehr gut, dann kann es weiter gehen.";
else
  echo "ich installiere azilink auf deinem Milestone";
  cd ${tools};
  adb install azilink.apk;
fi

echo "Dateien in ${home} werden erstellt"

cd ${home}
touch resolv.conf
echo "domain lan" >> resolv.conf
echo "search lan" >> resolv.conf
echo "nameserver 192.168.56.1" >> resolv.conf

touch milestone-tether.sh
echo "cd $HOME" >> milestone-tether.sh
echo "adb forward tcp:41927 tcp:41927" >> milestone-tether.sh
echo "sudo cp resolv.conf /etc/" >> milestone-tether.sh
echo "sudo openvpn --config azilink.ovpn" >> milestone-tether.sh
chmod 755 milestone-tether.sh

echo ""
echo "Nun starte die Applikation azilink auf deinem Milestone"
echo "und aktiviere die 'service active' Option, damit Verbindungen"
echo "vom PC empfangen werden können. Nun beende das Skript oder"
echo "starte in einer anderen Konsole folgenden Aufruf:"
echo ".${home}/milestone-tether.sh"
echo "solltest du bereits in deinem Home-Verzeichnis sein:"
echo "./milestone-tether.sh"
echo "Wenn alles klappt, dann solltest du nun über die Internet-"
echo "verbindung des Milestones surfen können."
echo ""
echo "Wenn du möchtest, kann ich das Skript in dein bin Verzeichnis"
echo "hinzufügen, dann kannst du den Aufruf von überall starten."
echo " Möchtest du das? [ j/n ]"
read response
echo ""

if [ $response == "j" ]; then
  sudo ln -s ${home}/milestone-tether.sh /usr/bin/milestone-tether
  echo "Ein Link wurde angelegt, nun kannst du den Befehlt immer"
  echo "aufrufen, sobald azilink am Milestone aktiviert ist."
  echo "Dazu einfach : milestone-tether eingeben."
else
  echo "ok"
fi

echo ""
echo "Das Skript kann nun per [Strg]+c abgebrochen werden."
echo "Du kannst auch einen Desktop Link anlegen und den Befehl"
echo "milestone-tether als Aufruf eingeben und somit die Verbindung"
echo "ohne Konsole starten"
echo ""
echo "Bei Fragen oder Problemen http://nodch.de/tether oder im" 
echo "http://alldroid.org/viewtopic.php?f=236&t=763 nachfragen!"
echo ""

